package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLMethod;

public class NormalMediatorEngine
extends GFRNEngine
{
   private  NormalMediatorEngine()
   {
   }

   private static NormalMediatorEngine theNormalMediatorEngine;

   public static NormalMediatorEngine get()
   {
      if (theNormalMediatorEngine == null)
      {
         theNormalMediatorEngine = new NormalMediatorEngine ();
      }
      return theNormalMediatorEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterColleagueAnnotationsGeneralization14 = null ;
      Iterator fujaba__IterColleagueAnnotationsGeneralization18 = null ;
      Iterator fujaba__IterColleagueAnnotationsGeneralization23 = null ;
      Iterator fujaba__IterColleagueAnnotationsGeneralization27 = null ;
      Iterator fujaba__IterColleagueAnnotationsGeneralization5 = null ;
      Iterator fujaba__IterColleagueAnnotationsGeneralization9 = null ;
      Iterator fujaba__IterColleagueAnnotationsNormalMediator = null ;
      Iterator fujaba__IterColleagueMethodsUMLMethod1 = null ;
      Iterator fujaba__IterConcreteColleague1MethodsUMLMethod22 = null ;
      Iterator fujaba__IterConcreteColleague1MethodsUMLMethod4 = null ;
      Iterator fujaba__IterConcreteColleague2MethodsUMLMethod26 = null ;
      Iterator fujaba__IterConcreteColleague2MethodsUMLMethod8 = null ;
      Iterator fujaba__IterGeneralization23ElementsConcreteColleague1 = null ;
      Iterator fujaba__IterGeneralization27ElementsConcreteColleague2 = null ;
      Iterator fujaba__IterGeneralization5ElementsConcreteColleague1 = null ;
      Iterator fujaba__IterGeneralization9ElementsConcreteColleague2 = null ;
      Iterator fujaba__IterM1AnnotationsNeighborCall12 = null ;
      Iterator fujaba__IterM1AnnotationsNeighborCall21 = null ;
      Iterator fujaba__IterM2AnnotationsNeighborCall16 = null ;
      Iterator fujaba__IterM2AnnotationsNeighborCall25 = null ;
      Iterator fujaba__IterMediatorAnnotationsNormalMediator = null ;
      Iterator fujaba__IterMediatorMethodsM1 = null ;
      Iterator fujaba__IterMediatorMethodsM2 = null ;
      Iterator fujaba__IterMediatorMethodsUMLMethod11 = null ;
      Iterator fujaba__IterNeighborCall12ElementsUMLMethod13 = null ;
      Iterator fujaba__IterNeighborCall15ElementsUMLMethod10 = null ;
      Iterator fujaba__IterNeighborCall16ElementsUMLMethod17 = null ;
      Iterator fujaba__IterNeighborCall24ElementsUMLMethod19 = null ;
      Iterator fujaba__IterNeighborCall24ElementsUMLMethod20 = null ;
      Iterator fujaba__IterNeighborCall6ElementsUMLMethod2 = null ;
      Iterator fujaba__IterUMLMethod11AnnotationsNeighborCall15 = null ;
      Iterator fujaba__IterUMLMethod1AnnotationsNeighborCall6 = null ;
      Iterator fujaba__IterUMLMethod4AnnotationsNeighborCall3 = null ;
      Iterator fujaba__IterUMLMethod8AnnotationsNeighborCall7 = null ;
      GeneralizationAnnotation generalization14 = null ;
      GeneralizationAnnotation generalization18 = null ;
      GeneralizationAnnotation generalization23 = null ;
      GeneralizationAnnotation generalization27 = null ;
      GeneralizationAnnotation generalization5 = null ;
      GeneralizationAnnotation generalization9 = null ;
      NeighborCallAnnotation neighborCall12 = null ;
      NeighborCallAnnotation neighborCall15 = null ;
      NeighborCallAnnotation neighborCall16 = null ;
      NeighborCallAnnotation neighborCall21 = null ;
      NeighborCallAnnotation neighborCall24 = null ;
      NeighborCallAnnotation neighborCall25 = null ;
      NeighborCallAnnotation neighborCall3 = null ;
      NeighborCallAnnotation neighborCall6 = null ;
      NeighborCallAnnotation neighborCall7 = null ;
      NormalMediatorAnnotation normalMediator = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLClass colleague = null ;
      de.uni_paderborn.fujaba.uml.UMLClass concreteColleague1 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass concreteColleague2 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass mediator = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod m1 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod m2 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod1 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod10 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod11 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod13 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod17 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod19 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod2 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod20 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod22 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod26 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod4 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod8 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("colleague", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            colleague = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // attribute condition
            JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
             
            // bind uMLMethod1: UMLMethod
            fujaba__IterColleagueMethodsUMLMethod1 = colleague.iteratorOfMethods () ;
            while ( fujaba__IterColleagueMethodsUMLMethod1.hasNext () )
            {
               try
               {
                  uMLMethod1 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterColleagueMethodsUMLMethod1.next () ;
                   
                  // bind generalization9: GeneralizationAnnotation
                  fujaba__IterColleagueAnnotationsGeneralization9 = colleague.iteratorOfAnnotations () ;
                  while ( fujaba__IterColleagueAnnotationsGeneralization9.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterColleagueAnnotationsGeneralization9.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization9 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization9 and colleague
                        JavaSDM.ensure ( generalization9.hasInElements ("superClass", colleague) ) ;
                         
                        // bind generalization5: GeneralizationAnnotation
                        fujaba__IterColleagueAnnotationsGeneralization5 = colleague.iteratorOfAnnotations () ;
                        while ( fujaba__IterColleagueAnnotationsGeneralization5.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterColleagueAnnotationsGeneralization5.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                              generalization5 = (GeneralizationAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between generalization5 and colleague
                              JavaSDM.ensure ( generalization5.hasInElements ("superClass", colleague) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(generalization9.equals (generalization5)) ) ;
                               
                              // bind neighborCall6: NeighborCallAnnotation
                              fujaba__IterUMLMethod1AnnotationsNeighborCall6 = uMLMethod1.iteratorOfAnnotations () ;
                              while ( fujaba__IterUMLMethod1AnnotationsNeighborCall6.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterUMLMethod1AnnotationsNeighborCall6.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                    neighborCall6 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between neighborCall6 and uMLMethod1
                                    JavaSDM.ensure ( neighborCall6.hasInElements ("caller", uMLMethod1) ) ;
                                     
                                    // bind concreteColleague2: UMLClass
                                    fujaba__IterGeneralization9ElementsConcreteColleague2 = generalization9.iteratorOfElements ("subClass") ;
                                    while ( fujaba__IterGeneralization9ElementsConcreteColleague2.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterGeneralization9ElementsConcreteColleague2.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                          concreteColleague2 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(colleague.equals (concreteColleague2)) ) ;
                                           
                                          // bind concreteColleague1: UMLClass
                                          fujaba__IterGeneralization5ElementsConcreteColleague1 = generalization5.iteratorOfElements ("subClass") ;
                                          while ( fujaba__IterGeneralization5ElementsConcreteColleague1.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterGeneralization5ElementsConcreteColleague1.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                concreteColleague1 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(colleague.equals (concreteColleague1)) && !(concreteColleague2.equals (concreteColleague1)) ) ;
                                                 
                                                // bind uMLMethod2: UMLMethod
                                                fujaba__IterNeighborCall6ElementsUMLMethod2 = neighborCall6.iteratorOfElements ("callee") ;
                                                while ( fujaba__IterNeighborCall6ElementsUMLMethod2.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterNeighborCall6ElementsUMLMethod2.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                      uMLMethod2 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(uMLMethod1.equals (uMLMethod2)) ) ;
                                                       
                                                      // bind mediator: UMLClass
                                                      mediator = uMLMethod2.getParent () ;
                                                      JavaSDM.ensure ( mediator != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(colleague.equals (mediator)) && !(concreteColleague1.equals (mediator)) && !(concreteColleague2.equals (mediator)) ) ;
                                                       
                                                      // bind uMLMethod8: UMLMethod
                                                      fujaba__IterConcreteColleague2MethodsUMLMethod8 = concreteColleague2.iteratorOfMethods () ;
                                                      while ( fujaba__IterConcreteColleague2MethodsUMLMethod8.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            uMLMethod8 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterConcreteColleague2MethodsUMLMethod8.next () ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(uMLMethod1.equals (uMLMethod8)) && !(uMLMethod2.equals (uMLMethod8)) ) ;
                                                             
                                                            // bind uMLMethod4: UMLMethod
                                                            fujaba__IterConcreteColleague1MethodsUMLMethod4 = concreteColleague1.iteratorOfMethods () ;
                                                            while ( fujaba__IterConcreteColleague1MethodsUMLMethod4.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  uMLMethod4 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterConcreteColleague1MethodsUMLMethod4.next () ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(uMLMethod1.equals (uMLMethod4)) && !(uMLMethod2.equals (uMLMethod4)) && !(uMLMethod8.equals (uMLMethod4)) ) ;
                                                                   
                                                                  // bind m1: UMLMethod
                                                                  fujaba__IterMediatorMethodsM1 = mediator.iteratorOfMethods () ;
                                                                  while ( fujaba__IterMediatorMethodsM1.hasNext () )
                                                                  {
                                                                     try
                                                                     {
                                                                        m1 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterMediatorMethodsM1.next () ;
                                                                         
                                                                        // check isomorphic binding
                                                                        JavaSDM.ensure ( !(uMLMethod1.equals (m1)) && !(uMLMethod2.equals (m1)) && !(uMLMethod4.equals (m1)) && !(uMLMethod8.equals (m1)) ) ;
                                                                         
                                                                        // bind m2: UMLMethod
                                                                        fujaba__IterMediatorMethodsM2 = mediator.iteratorOfMethods () ;
                                                                        while ( fujaba__IterMediatorMethodsM2.hasNext () )
                                                                        {
                                                                           try
                                                                           {
                                                                              m2 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterMediatorMethodsM2.next () ;
                                                                               
                                                                              // check isomorphic binding
                                                                              JavaSDM.ensure ( !(uMLMethod1.equals (m2)) && !(uMLMethod2.equals (m2)) && !(uMLMethod4.equals (m2)) && !(uMLMethod8.equals (m2)) ) ;
                                                                               
                                                                              // bind neighborCall7: NeighborCallAnnotation
                                                                              fujaba__IterUMLMethod8AnnotationsNeighborCall7 = uMLMethod8.iteratorOfAnnotations () ;
                                                                              while ( fujaba__IterUMLMethod8AnnotationsNeighborCall7.hasNext () )
                                                                              {
                                                                                 try
                                                                                 {
                                                                                    fujaba__TmpObject = fujaba__IterUMLMethod8AnnotationsNeighborCall7.next () ;
                                                                                    JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                                                                    neighborCall7 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                                                                     
                                                                                    // check Reverse-Qualified-Link 'elements' between neighborCall7 and uMLMethod8
                                                                                    JavaSDM.ensure ( neighborCall7.hasInElements ("callee", uMLMethod8) ) ;
                                                                                     
                                                                                    // check isomorphic binding
                                                                                    JavaSDM.ensure ( !(neighborCall6.equals (neighborCall7)) ) ;
                                                                                     
                                                                                    // check To-Many-Link 'elements' between neighborCall7 and m2
                                                                                    JavaSDM.ensure ( neighborCall7.hasInElements ("caller", m2) ) ;
                                                                                     
                                                                                    // bind neighborCall3: NeighborCallAnnotation
                                                                                    fujaba__IterUMLMethod4AnnotationsNeighborCall3 = uMLMethod4.iteratorOfAnnotations () ;
                                                                                    while ( fujaba__IterUMLMethod4AnnotationsNeighborCall3.hasNext () )
                                                                                    {
                                                                                       try
                                                                                       {
                                                                                          fujaba__TmpObject = fujaba__IterUMLMethod4AnnotationsNeighborCall3.next () ;
                                                                                          JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                                                                          neighborCall3 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                                                                           
                                                                                          // check Reverse-Qualified-Link 'elements' between neighborCall3 and uMLMethod4
                                                                                          JavaSDM.ensure ( neighborCall3.hasInElements ("callee", uMLMethod4) ) ;
                                                                                           
                                                                                          // check isomorphic binding
                                                                                          JavaSDM.ensure ( !(neighborCall6.equals (neighborCall3)) && !(neighborCall7.equals (neighborCall3)) ) ;
                                                                                           
                                                                                          // check To-Many-Link 'elements' between neighborCall3 and m1
                                                                                          JavaSDM.ensure ( neighborCall3.hasInElements ("caller", m1) ) ;
                                                                                           
                                                                                          {
                                                                                             //  for each flow
                                                                                             try
                                                                                             {
                                                                                                fujaba__Success = false ;
                                                                                                 
                                                                                                // check object mediator is really bound
                                                                                                JavaSDM.ensure ( mediator != null ) ;
                                                                                                 
                                                                                                // check object colleague is really bound
                                                                                                JavaSDM.ensure ( colleague != null ) ;
                                                                                                 
                                                                                                // check isomorphic binding
                                                                                                JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                                                                                                 
                                                                                                // bind normalMediator: NormalMediatorAnnotation
                                                                                                fujaba__IterColleagueAnnotationsNormalMediator = colleague.iteratorOfAnnotations () ;
                                                                                                while ( !(fujaba__Success) && fujaba__IterColleagueAnnotationsNormalMediator.hasNext () )
                                                                                                {
                                                                                                   try
                                                                                                   {
                                                                                                      fujaba__TmpObject = fujaba__IterColleagueAnnotationsNormalMediator.next () ;
                                                                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof NormalMediatorAnnotation ) ;
                                                                                                      normalMediator = (NormalMediatorAnnotation) fujaba__TmpObject ;
                                                                                                       
                                                                                                      // check Reverse-Qualified-Link 'elements' between normalMediator and colleague
                                                                                                      JavaSDM.ensure ( normalMediator.hasInElements ("colleague", colleague) ) ;
                                                                                                       
                                                                                                      // check To-Many-Link 'elements' between normalMediator and mediator
                                                                                                      JavaSDM.ensure ( normalMediator.hasInElements ("mediator", mediator) ) ;
                                                                                                       
                                                                                                      fujaba__Success = true ;
                                                                                                   }
                                                                                                   catch ( JavaSDMException fujaba__InternalException )
                                                                                                   {
                                                                                                   }
                                                                                                }
                                                                                             }
                                                                                             catch ( JavaSDMException fujaba__InternalException )
                                                                                             {
                                                                                                fujaba__Success = false ;
                                                                                             }
                                                                                              
                                                                                             if ( !(fujaba__Success) )
                                                                                             {
                                                                                                try
                                                                                                {
                                                                                                   fujaba__Success = false ;
                                                                                                    
                                                                                                   // check object mediator is really bound
                                                                                                   JavaSDM.ensure ( mediator != null ) ;
                                                                                                    
                                                                                                   // check object colleague is really bound
                                                                                                   JavaSDM.ensure ( colleague != null ) ;
                                                                                                    
                                                                                                   // check isomorphic binding
                                                                                                   JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                                                                                                    
                                                                                                   // check object m1 is really bound
                                                                                                   JavaSDM.ensure ( m1 != null ) ;
                                                                                                    
                                                                                                   // check object concreteColleague1 is really bound
                                                                                                   JavaSDM.ensure ( concreteColleague1 != null ) ;
                                                                                                    
                                                                                                   // check isomorphic binding
                                                                                                   JavaSDM.ensure ( !(mediator.equals (concreteColleague1)) && !(colleague.equals (concreteColleague1)) ) ;
                                                                                                    
                                                                                                   // check object concreteColleague2 is really bound
                                                                                                   JavaSDM.ensure ( concreteColleague2 != null ) ;
                                                                                                    
                                                                                                   // check isomorphic binding
                                                                                                   JavaSDM.ensure ( !(mediator.equals (concreteColleague2)) && !(colleague.equals (concreteColleague2)) && !(concreteColleague1.equals (concreteColleague2)) ) ;
                                                                                                    
                                                                                                   // check object m2 is really bound
                                                                                                   JavaSDM.ensure ( m2 != null ) ;
                                                                                                    
                                                                                                   // create object
                                                                                                   normalMediator = new NormalMediatorAnnotation ( ) ;
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToElements ("mediator", mediator);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToElements ("colleague", colleague);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToBoundObjects ("colleague", colleague);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToBoundObjects ("mediator", mediator);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToBoundObjects ("m1", m1);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToBoundObjects ("concreteColleague1", concreteColleague1);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToBoundObjects ("concreteColleague2", concreteColleague2);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToBoundObjects ("m2", m2);
                                                                                                    
                                                                                                   fujaba__Success = true ;
                                                                                                }
                                                                                                catch ( JavaSDMException fujaba__InternalException )
                                                                                                {
                                                                                                   fujaba__Success = false ;
                                                                                                }
                                                                                                 
                                                                                                try
                                                                                                {
                                                                                                   fujaba__Success = false ;
                                                                                                    
                                                                                                   // check object neighborCall3 is really bound
                                                                                                   JavaSDM.ensure ( neighborCall3 != null ) ;
                                                                                                    
                                                                                                   // check object generalization5 is really bound
                                                                                                   JavaSDM.ensure ( generalization5 != null ) ;
                                                                                                    
                                                                                                   // check object neighborCall6 is really bound
                                                                                                   JavaSDM.ensure ( neighborCall6 != null ) ;
                                                                                                    
                                                                                                   // check isomorphic binding
                                                                                                   JavaSDM.ensure ( !(neighborCall3.equals (neighborCall6)) ) ;
                                                                                                    
                                                                                                   // check object neighborCall7 is really bound
                                                                                                   JavaSDM.ensure ( neighborCall7 != null ) ;
                                                                                                    
                                                                                                   // check isomorphic binding
                                                                                                   JavaSDM.ensure ( !(neighborCall3.equals (neighborCall7)) && !(neighborCall6.equals (neighborCall7)) ) ;
                                                                                                    
                                                                                                   // check object generalization9 is really bound
                                                                                                   JavaSDM.ensure ( generalization9 != null ) ;
                                                                                                    
                                                                                                   // check isomorphic binding
                                                                                                   JavaSDM.ensure ( !(generalization5.equals (generalization9)) ) ;
                                                                                                    
                                                                                                   // check object normalMediator is really bound
                                                                                                   JavaSDM.ensure ( normalMediator != null ) ;
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToAntecedentAnnos (neighborCall3);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToAntecedentAnnos (generalization5);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToAntecedentAnnos (neighborCall6);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToAntecedentAnnos (neighborCall7);
                                                                                                    
                                                                                                   // create link
                                                                                                   normalMediator.addToAntecedentAnnos (generalization9);
                                                                                                    
                                                                                                   fujaba__Success = true ;
                                                                                                }
                                                                                                catch ( JavaSDMException fujaba__InternalException )
                                                                                                {
                                                                                                   fujaba__Success = false ;
                                                                                                }
                                                                                                 
                                                                                                return (normalMediator) ;
                                                                                             }
                                                                                          } //  end for each flow
                                                                                       }
                                                                                       catch ( JavaSDMException fujaba__InternalException )
                                                                                       {
                                                                                       }
                                                                                    }
                                                                                 }
                                                                                 catch ( JavaSDMException fujaba__InternalException )
                                                                                 {
                                                                                 }
                                                                              }
                                                                           }
                                                                           catch ( JavaSDMException fujaba__InternalException )
                                                                           {
                                                                           }
                                                                        }
                                                                     }
                                                                     catch ( JavaSDMException fujaba__InternalException )
                                                                     {
                                                                     }
                                                                  }
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object normalMediator is really bound
            JavaSDM.ensure ( normalMediator != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("colleague", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("mediator", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            mediator = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod11: UMLMethod
            fujaba__IterMediatorMethodsUMLMethod11 = mediator.iteratorOfMethods () ;
            while ( fujaba__IterMediatorMethodsUMLMethod11.hasNext () )
            {
               try
               {
                  uMLMethod11 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterMediatorMethodsUMLMethod11.next () ;
                   
                  // bind m1: UMLMethod
                  fujaba__IterMediatorMethodsM1 = mediator.iteratorOfMethods () ;
                  while ( fujaba__IterMediatorMethodsM1.hasNext () )
                  {
                     try
                     {
                        m1 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterMediatorMethodsM1.next () ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(uMLMethod11.equals (m1)) ) ;
                         
                        // bind m2: UMLMethod
                        fujaba__IterMediatorMethodsM2 = mediator.iteratorOfMethods () ;
                        while ( fujaba__IterMediatorMethodsM2.hasNext () )
                        {
                           try
                           {
                              m2 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterMediatorMethodsM2.next () ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLMethod11.equals (m2)) ) ;
                               
                              // bind neighborCall15: NeighborCallAnnotation
                              fujaba__IterUMLMethod11AnnotationsNeighborCall15 = uMLMethod11.iteratorOfAnnotations () ;
                              while ( fujaba__IterUMLMethod11AnnotationsNeighborCall15.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterUMLMethod11AnnotationsNeighborCall15.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                    neighborCall15 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between neighborCall15 and uMLMethod11
                                    JavaSDM.ensure ( neighborCall15.hasInElements ("callee", uMLMethod11) ) ;
                                     
                                    // bind neighborCall12: NeighborCallAnnotation
                                    fujaba__IterM1AnnotationsNeighborCall12 = m1.iteratorOfAnnotations () ;
                                    while ( fujaba__IterM1AnnotationsNeighborCall12.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterM1AnnotationsNeighborCall12.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                          neighborCall12 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between neighborCall12 and m1
                                          JavaSDM.ensure ( neighborCall12.hasInElements ("caller", m1) ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(neighborCall15.equals (neighborCall12)) ) ;
                                           
                                          // bind neighborCall16: NeighborCallAnnotation
                                          fujaba__IterM2AnnotationsNeighborCall16 = m2.iteratorOfAnnotations () ;
                                          while ( fujaba__IterM2AnnotationsNeighborCall16.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterM2AnnotationsNeighborCall16.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                                neighborCall16 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between neighborCall16 and m2
                                                JavaSDM.ensure ( neighborCall16.hasInElements ("caller", m2) ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(neighborCall12.equals (neighborCall16)) && !(neighborCall15.equals (neighborCall16)) ) ;
                                                 
                                                // bind uMLMethod10: UMLMethod
                                                fujaba__IterNeighborCall15ElementsUMLMethod10 = neighborCall15.iteratorOfElements ("caller") ;
                                                while ( fujaba__IterNeighborCall15ElementsUMLMethod10.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterNeighborCall15ElementsUMLMethod10.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                      uMLMethod10 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(uMLMethod11.equals (uMLMethod10)) && !(m1.equals (uMLMethod10)) && !(m2.equals (uMLMethod10)) ) ;
                                                       
                                                      // bind colleague: UMLClass
                                                      colleague = uMLMethod10.getParent () ;
                                                      JavaSDM.ensure ( colleague != null ) ;
                                                       
                                                      // attribute condition
                                                      JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                                                       
                                                      // bind uMLMethod13: UMLMethod
                                                      fujaba__IterNeighborCall12ElementsUMLMethod13 = neighborCall12.iteratorOfElements ("callee") ;
                                                      while ( fujaba__IterNeighborCall12ElementsUMLMethod13.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterNeighborCall12ElementsUMLMethod13.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                            uMLMethod13 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(uMLMethod10.equals (uMLMethod13)) && !(uMLMethod11.equals (uMLMethod13)) && !(m1.equals (uMLMethod13)) && !(m2.equals (uMLMethod13)) ) ;
                                                             
                                                            // bind concreteColleague1: UMLClass
                                                            concreteColleague1 = uMLMethod13.getParent () ;
                                                            JavaSDM.ensure ( concreteColleague1 != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(colleague.equals (concreteColleague1)) && !(mediator.equals (concreteColleague1)) ) ;
                                                             
                                                            // bind uMLMethod17: UMLMethod
                                                            fujaba__IterNeighborCall16ElementsUMLMethod17 = neighborCall16.iteratorOfElements ("callee") ;
                                                            while ( fujaba__IterNeighborCall16ElementsUMLMethod17.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterNeighborCall16ElementsUMLMethod17.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                                  uMLMethod17 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(uMLMethod10.equals (uMLMethod17)) && !(uMLMethod11.equals (uMLMethod17)) && !(m1.equals (uMLMethod17)) && !(uMLMethod13.equals (uMLMethod17)) && !(m2.equals (uMLMethod17)) ) ;
                                                                   
                                                                  // bind concreteColleague2: UMLClass
                                                                  concreteColleague2 = uMLMethod17.getParent () ;
                                                                  JavaSDM.ensure ( concreteColleague2 != null ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(colleague.equals (concreteColleague2)) && !(mediator.equals (concreteColleague2)) && !(concreteColleague1.equals (concreteColleague2)) ) ;
                                                                   
                                                                  // bind generalization18: GeneralizationAnnotation
                                                                  fujaba__IterColleagueAnnotationsGeneralization18 = colleague.iteratorOfAnnotations () ;
                                                                  while ( fujaba__IterColleagueAnnotationsGeneralization18.hasNext () )
                                                                  {
                                                                     try
                                                                     {
                                                                        fujaba__TmpObject = fujaba__IterColleagueAnnotationsGeneralization18.next () ;
                                                                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                                        generalization18 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                                         
                                                                        // check Reverse-Qualified-Link 'elements' between generalization18 and colleague
                                                                        JavaSDM.ensure ( generalization18.hasInElements ("superClass", colleague) ) ;
                                                                         
                                                                        // check To-Many-Link 'elements' between generalization18 and concreteColleague2
                                                                        JavaSDM.ensure ( generalization18.hasInElements ("subClass", concreteColleague2) ) ;
                                                                         
                                                                        // bind generalization14: GeneralizationAnnotation
                                                                        fujaba__IterColleagueAnnotationsGeneralization14 = colleague.iteratorOfAnnotations () ;
                                                                        while ( fujaba__IterColleagueAnnotationsGeneralization14.hasNext () )
                                                                        {
                                                                           try
                                                                           {
                                                                              fujaba__TmpObject = fujaba__IterColleagueAnnotationsGeneralization14.next () ;
                                                                              JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                                              generalization14 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                                               
                                                                              // check Reverse-Qualified-Link 'elements' between generalization14 and colleague
                                                                              JavaSDM.ensure ( generalization14.hasInElements ("superClass", colleague) ) ;
                                                                               
                                                                              // check isomorphic binding
                                                                              JavaSDM.ensure ( !(generalization18.equals (generalization14)) ) ;
                                                                               
                                                                              // check To-Many-Link 'elements' between generalization14 and concreteColleague1
                                                                              JavaSDM.ensure ( generalization14.hasInElements ("subClass", concreteColleague1) ) ;
                                                                               
                                                                              {
                                                                                 //  for each flow
                                                                                 try
                                                                                 {
                                                                                    fujaba__Success = false ;
                                                                                     
                                                                                    // check object mediator is really bound
                                                                                    JavaSDM.ensure ( mediator != null ) ;
                                                                                     
                                                                                    // check object colleague is really bound
                                                                                    JavaSDM.ensure ( colleague != null ) ;
                                                                                     
                                                                                    // check isomorphic binding
                                                                                    JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                                                                                     
                                                                                    // bind normalMediator: NormalMediatorAnnotation
                                                                                    fujaba__IterMediatorAnnotationsNormalMediator = mediator.iteratorOfAnnotations () ;
                                                                                    while ( !(fujaba__Success) && fujaba__IterMediatorAnnotationsNormalMediator.hasNext () )
                                                                                    {
                                                                                       try
                                                                                       {
                                                                                          fujaba__TmpObject = fujaba__IterMediatorAnnotationsNormalMediator.next () ;
                                                                                          JavaSDM.ensure ( fujaba__TmpObject instanceof NormalMediatorAnnotation ) ;
                                                                                          normalMediator = (NormalMediatorAnnotation) fujaba__TmpObject ;
                                                                                           
                                                                                          // check Reverse-Qualified-Link 'elements' between normalMediator and mediator
                                                                                          JavaSDM.ensure ( normalMediator.hasInElements ("mediator", mediator) ) ;
                                                                                           
                                                                                          // check To-Many-Link 'elements' between normalMediator and colleague
                                                                                          JavaSDM.ensure ( normalMediator.hasInElements ("colleague", colleague) ) ;
                                                                                           
                                                                                          fujaba__Success = true ;
                                                                                       }
                                                                                       catch ( JavaSDMException fujaba__InternalException )
                                                                                       {
                                                                                       }
                                                                                    }
                                                                                 }
                                                                                 catch ( JavaSDMException fujaba__InternalException )
                                                                                 {
                                                                                    fujaba__Success = false ;
                                                                                 }
                                                                                  
                                                                                 if ( !(fujaba__Success) )
                                                                                 {
                                                                                    try
                                                                                    {
                                                                                       fujaba__Success = false ;
                                                                                        
                                                                                       // check object mediator is really bound
                                                                                       JavaSDM.ensure ( mediator != null ) ;
                                                                                        
                                                                                       // check object colleague is really bound
                                                                                       JavaSDM.ensure ( colleague != null ) ;
                                                                                        
                                                                                       // check isomorphic binding
                                                                                       JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                                                                                        
                                                                                       // check object m1 is really bound
                                                                                       JavaSDM.ensure ( m1 != null ) ;
                                                                                        
                                                                                       // check object concreteColleague1 is really bound
                                                                                       JavaSDM.ensure ( concreteColleague1 != null ) ;
                                                                                        
                                                                                       // check isomorphic binding
                                                                                       JavaSDM.ensure ( !(mediator.equals (concreteColleague1)) && !(colleague.equals (concreteColleague1)) ) ;
                                                                                        
                                                                                       // check object concreteColleague2 is really bound
                                                                                       JavaSDM.ensure ( concreteColleague2 != null ) ;
                                                                                        
                                                                                       // check isomorphic binding
                                                                                       JavaSDM.ensure ( !(mediator.equals (concreteColleague2)) && !(colleague.equals (concreteColleague2)) && !(concreteColleague1.equals (concreteColleague2)) ) ;
                                                                                        
                                                                                       // check object m2 is really bound
                                                                                       JavaSDM.ensure ( m2 != null ) ;
                                                                                        
                                                                                       // create object
                                                                                       normalMediator = new NormalMediatorAnnotation ( ) ;
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToElements ("mediator", mediator);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToElements ("colleague", colleague);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToBoundObjects ("colleague", colleague);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToBoundObjects ("mediator", mediator);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToBoundObjects ("m1", m1);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToBoundObjects ("concreteColleague1", concreteColleague1);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToBoundObjects ("concreteColleague2", concreteColleague2);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToBoundObjects ("m2", m2);
                                                                                        
                                                                                       fujaba__Success = true ;
                                                                                    }
                                                                                    catch ( JavaSDMException fujaba__InternalException )
                                                                                    {
                                                                                       fujaba__Success = false ;
                                                                                    }
                                                                                     
                                                                                    try
                                                                                    {
                                                                                       fujaba__Success = false ;
                                                                                        
                                                                                       // check object neighborCall12 is really bound
                                                                                       JavaSDM.ensure ( neighborCall12 != null ) ;
                                                                                        
                                                                                       // check object generalization14 is really bound
                                                                                       JavaSDM.ensure ( generalization14 != null ) ;
                                                                                        
                                                                                       // check object neighborCall15 is really bound
                                                                                       JavaSDM.ensure ( neighborCall15 != null ) ;
                                                                                        
                                                                                       // check isomorphic binding
                                                                                       JavaSDM.ensure ( !(neighborCall12.equals (neighborCall15)) ) ;
                                                                                        
                                                                                       // check object neighborCall16 is really bound
                                                                                       JavaSDM.ensure ( neighborCall16 != null ) ;
                                                                                        
                                                                                       // check isomorphic binding
                                                                                       JavaSDM.ensure ( !(neighborCall12.equals (neighborCall16)) && !(neighborCall15.equals (neighborCall16)) ) ;
                                                                                        
                                                                                       // check object generalization18 is really bound
                                                                                       JavaSDM.ensure ( generalization18 != null ) ;
                                                                                        
                                                                                       // check isomorphic binding
                                                                                       JavaSDM.ensure ( !(generalization14.equals (generalization18)) ) ;
                                                                                        
                                                                                       // check object normalMediator is really bound
                                                                                       JavaSDM.ensure ( normalMediator != null ) ;
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToAntecedentAnnos (neighborCall12);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToAntecedentAnnos (generalization14);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToAntecedentAnnos (neighborCall15);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToAntecedentAnnos (neighborCall16);
                                                                                        
                                                                                       // create link
                                                                                       normalMediator.addToAntecedentAnnos (generalization18);
                                                                                        
                                                                                       fujaba__Success = true ;
                                                                                    }
                                                                                    catch ( JavaSDMException fujaba__InternalException )
                                                                                    {
                                                                                       fujaba__Success = false ;
                                                                                    }
                                                                                     
                                                                                    return (normalMediator) ;
                                                                                 }
                                                                              } //  end for each flow
                                                                           }
                                                                           catch ( JavaSDMException fujaba__InternalException )
                                                                           {
                                                                           }
                                                                        }
                                                                     }
                                                                     catch ( JavaSDMException fujaba__InternalException )
                                                                     {
                                                                     }
                                                                  }
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object normalMediator is really bound
            JavaSDM.ensure ( normalMediator != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("mediator", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall24 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod19: UMLMethod
            fujaba__IterNeighborCall24ElementsUMLMethod19 = neighborCall24.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall24ElementsUMLMethod19.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall24ElementsUMLMethod19.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod19 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind colleague: UMLClass
                  colleague = uMLMethod19.getParent () ;
                  JavaSDM.ensure ( colleague != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                   
                  // bind uMLMethod20: UMLMethod
                  fujaba__IterNeighborCall24ElementsUMLMethod20 = neighborCall24.iteratorOfElements ("callee") ;
                  while ( fujaba__IterNeighborCall24ElementsUMLMethod20.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterNeighborCall24ElementsUMLMethod20.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        uMLMethod20 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(uMLMethod19.equals (uMLMethod20)) ) ;
                         
                        // bind mediator: UMLClass
                        mediator = uMLMethod20.getParent () ;
                        JavaSDM.ensure ( mediator != null ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(colleague.equals (mediator)) ) ;
                         
                        // bind generalization27: GeneralizationAnnotation
                        fujaba__IterColleagueAnnotationsGeneralization27 = colleague.iteratorOfAnnotations () ;
                        while ( fujaba__IterColleagueAnnotationsGeneralization27.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterColleagueAnnotationsGeneralization27.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                              generalization27 = (GeneralizationAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between generalization27 and colleague
                              JavaSDM.ensure ( generalization27.hasInElements ("superClass", colleague) ) ;
                               
                              // bind generalization23: GeneralizationAnnotation
                              fujaba__IterColleagueAnnotationsGeneralization23 = colleague.iteratorOfAnnotations () ;
                              while ( fujaba__IterColleagueAnnotationsGeneralization23.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterColleagueAnnotationsGeneralization23.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                    generalization23 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between generalization23 and colleague
                                    JavaSDM.ensure ( generalization23.hasInElements ("superClass", colleague) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(generalization27.equals (generalization23)) ) ;
                                     
                                    // bind m1: UMLMethod
                                    fujaba__IterMediatorMethodsM1 = mediator.iteratorOfMethods () ;
                                    while ( fujaba__IterMediatorMethodsM1.hasNext () )
                                    {
                                       try
                                       {
                                          m1 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterMediatorMethodsM1.next () ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLMethod19.equals (m1)) && !(uMLMethod20.equals (m1)) ) ;
                                           
                                          // bind m2: UMLMethod
                                          fujaba__IterMediatorMethodsM2 = mediator.iteratorOfMethods () ;
                                          while ( fujaba__IterMediatorMethodsM2.hasNext () )
                                          {
                                             try
                                             {
                                                m2 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterMediatorMethodsM2.next () ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(uMLMethod19.equals (m2)) && !(uMLMethod20.equals (m2)) ) ;
                                                 
                                                // bind concreteColleague2: UMLClass
                                                fujaba__IterGeneralization27ElementsConcreteColleague2 = generalization27.iteratorOfElements ("subClass") ;
                                                while ( fujaba__IterGeneralization27ElementsConcreteColleague2.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterGeneralization27ElementsConcreteColleague2.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                      concreteColleague2 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(colleague.equals (concreteColleague2)) && !(mediator.equals (concreteColleague2)) ) ;
                                                       
                                                      // bind concreteColleague1: UMLClass
                                                      fujaba__IterGeneralization23ElementsConcreteColleague1 = generalization23.iteratorOfElements ("subClass") ;
                                                      while ( fujaba__IterGeneralization23ElementsConcreteColleague1.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterGeneralization23ElementsConcreteColleague1.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                            concreteColleague1 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(colleague.equals (concreteColleague1)) && !(mediator.equals (concreteColleague1)) && !(concreteColleague2.equals (concreteColleague1)) ) ;
                                                             
                                                            // bind neighborCall21: NeighborCallAnnotation
                                                            fujaba__IterM1AnnotationsNeighborCall21 = m1.iteratorOfAnnotations () ;
                                                            while ( fujaba__IterM1AnnotationsNeighborCall21.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterM1AnnotationsNeighborCall21.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                                                  neighborCall21 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                                                   
                                                                  // check Reverse-Qualified-Link 'elements' between neighborCall21 and m1
                                                                  JavaSDM.ensure ( neighborCall21.hasInElements ("caller", m1) ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(neighborCall24.equals (neighborCall21)) ) ;
                                                                   
                                                                  // bind neighborCall25: NeighborCallAnnotation
                                                                  fujaba__IterM2AnnotationsNeighborCall25 = m2.iteratorOfAnnotations () ;
                                                                  while ( fujaba__IterM2AnnotationsNeighborCall25.hasNext () )
                                                                  {
                                                                     try
                                                                     {
                                                                        fujaba__TmpObject = fujaba__IterM2AnnotationsNeighborCall25.next () ;
                                                                        JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                                                        neighborCall25 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                                                         
                                                                        // check Reverse-Qualified-Link 'elements' between neighborCall25 and m2
                                                                        JavaSDM.ensure ( neighborCall25.hasInElements ("caller", m2) ) ;
                                                                         
                                                                        // check isomorphic binding
                                                                        JavaSDM.ensure ( !(neighborCall21.equals (neighborCall25)) && !(neighborCall24.equals (neighborCall25)) ) ;
                                                                         
                                                                        // bind uMLMethod26: UMLMethod
                                                                        fujaba__IterConcreteColleague2MethodsUMLMethod26 = concreteColleague2.iteratorOfMethods () ;
                                                                        while ( fujaba__IterConcreteColleague2MethodsUMLMethod26.hasNext () )
                                                                        {
                                                                           try
                                                                           {
                                                                              uMLMethod26 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterConcreteColleague2MethodsUMLMethod26.next () ;
                                                                               
                                                                              // check isomorphic binding
                                                                              JavaSDM.ensure ( !(uMLMethod19.equals (uMLMethod26)) && !(uMLMethod20.equals (uMLMethod26)) && !(m1.equals (uMLMethod26)) && !(m2.equals (uMLMethod26)) ) ;
                                                                               
                                                                              // check To-Many-Link 'elements' between neighborCall25 and uMLMethod26
                                                                              JavaSDM.ensure ( neighborCall25.hasInElements ("callee", uMLMethod26) ) ;
                                                                               
                                                                              // bind uMLMethod22: UMLMethod
                                                                              fujaba__IterConcreteColleague1MethodsUMLMethod22 = concreteColleague1.iteratorOfMethods () ;
                                                                              while ( fujaba__IterConcreteColleague1MethodsUMLMethod22.hasNext () )
                                                                              {
                                                                                 try
                                                                                 {
                                                                                    uMLMethod22 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterConcreteColleague1MethodsUMLMethod22.next () ;
                                                                                     
                                                                                    // check isomorphic binding
                                                                                    JavaSDM.ensure ( !(uMLMethod19.equals (uMLMethod22)) && !(uMLMethod20.equals (uMLMethod22)) && !(m1.equals (uMLMethod22)) && !(uMLMethod26.equals (uMLMethod22)) && !(m2.equals (uMLMethod22)) ) ;
                                                                                     
                                                                                    // check To-Many-Link 'elements' between neighborCall21 and uMLMethod22
                                                                                    JavaSDM.ensure ( neighborCall21.hasInElements ("callee", uMLMethod22) ) ;
                                                                                     
                                                                                    {
                                                                                       //  for each flow
                                                                                       try
                                                                                       {
                                                                                          fujaba__Success = false ;
                                                                                           
                                                                                          // check object mediator is really bound
                                                                                          JavaSDM.ensure ( mediator != null ) ;
                                                                                           
                                                                                          // check object colleague is really bound
                                                                                          JavaSDM.ensure ( colleague != null ) ;
                                                                                           
                                                                                          // check isomorphic binding
                                                                                          JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                                                                                           
                                                                                          // bind normalMediator: NormalMediatorAnnotation
                                                                                          fujaba__IterColleagueAnnotationsNormalMediator = colleague.iteratorOfAnnotations () ;
                                                                                          while ( !(fujaba__Success) && fujaba__IterColleagueAnnotationsNormalMediator.hasNext () )
                                                                                          {
                                                                                             try
                                                                                             {
                                                                                                fujaba__TmpObject = fujaba__IterColleagueAnnotationsNormalMediator.next () ;
                                                                                                JavaSDM.ensure ( fujaba__TmpObject instanceof NormalMediatorAnnotation ) ;
                                                                                                normalMediator = (NormalMediatorAnnotation) fujaba__TmpObject ;
                                                                                                 
                                                                                                // check Reverse-Qualified-Link 'elements' between normalMediator and colleague
                                                                                                JavaSDM.ensure ( normalMediator.hasInElements ("colleague", colleague) ) ;
                                                                                                 
                                                                                                // check To-Many-Link 'elements' between normalMediator and mediator
                                                                                                JavaSDM.ensure ( normalMediator.hasInElements ("mediator", mediator) ) ;
                                                                                                 
                                                                                                fujaba__Success = true ;
                                                                                             }
                                                                                             catch ( JavaSDMException fujaba__InternalException )
                                                                                             {
                                                                                             }
                                                                                          }
                                                                                       }
                                                                                       catch ( JavaSDMException fujaba__InternalException )
                                                                                       {
                                                                                          fujaba__Success = false ;
                                                                                       }
                                                                                        
                                                                                       if ( !(fujaba__Success) )
                                                                                       {
                                                                                          try
                                                                                          {
                                                                                             fujaba__Success = false ;
                                                                                              
                                                                                             // check object mediator is really bound
                                                                                             JavaSDM.ensure ( mediator != null ) ;
                                                                                              
                                                                                             // check object colleague is really bound
                                                                                             JavaSDM.ensure ( colleague != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                                                                                              
                                                                                             // check object m1 is really bound
                                                                                             JavaSDM.ensure ( m1 != null ) ;
                                                                                              
                                                                                             // check object concreteColleague1 is really bound
                                                                                             JavaSDM.ensure ( concreteColleague1 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(mediator.equals (concreteColleague1)) && !(colleague.equals (concreteColleague1)) ) ;
                                                                                              
                                                                                             // check object concreteColleague2 is really bound
                                                                                             JavaSDM.ensure ( concreteColleague2 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(mediator.equals (concreteColleague2)) && !(colleague.equals (concreteColleague2)) && !(concreteColleague1.equals (concreteColleague2)) ) ;
                                                                                              
                                                                                             // check object m2 is really bound
                                                                                             JavaSDM.ensure ( m2 != null ) ;
                                                                                              
                                                                                             // create object
                                                                                             normalMediator = new NormalMediatorAnnotation ( ) ;
                                                                                              
                                                                                             // create link
                                                                                             normalMediator.addToElements ("mediator", mediator);
                                                                                              
                                                                                             // create link
                                                                                             normalMediator.addToElements ("colleague", colleague);
                                                                                              
                                                                                             // create link
                                                                                             normalMediator.addToBoundObjects ("colleague", colleague);
                                                                                              
                                                                                             // create link
                                                                                             normalMediator.addToBoundObjects ("mediator", mediator);
                                                                                              
                                                                                             // create link
                                                                                             normalMediator.addToBoundObjects ("m1", m1);
                                                                                              
                                                                                             // create link
                                                                                             normalMediator.addToBoundObjects ("concreteColleague1", concreteColleague1);
                                                                                              
                                                                                             // create link
                                                                                             normalMediator.addToBoundObjects ("concreteColleague2", concreteColleague2);
                                                                                              
                                                                                             // create link
                                                                                             normalMediator.addToBoundObjects ("m2", m2);
                                                                                              
                                                                                             fujaba__Success = true ;
                                                                                          }
                                                                                          catch ( JavaSDMException fujaba__InternalException )
                                                                                          {
                                                                                             fujaba__Success = false ;
                                                                                          }
                                                                                           
                                                                                          try
                                                                                          {
                                                                                             fujaba__Success = false ;
                                                                                              
                                                                                             // check object neighborCall21 is really bound
                                                                                             JavaSDM.ensure ( neighborCall21 != null ) ;
                                                                                              
                                                                                             // check object generalization23 is really bound
                                                                                             JavaSDM.ensure ( generalization23 != null ) ;
                                                                                              
                                                                                             // check object neighborCall24 is really bound
                                                                                             JavaSDM.ensure ( neighborCall24 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(neighborCall21.equals (neighborCall24)) ) ;
                                                                                              
                                                                                             // check object neighborCall25 is really bound
                                                                                             JavaSDM.ensure ( neighborCall25 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(neighborCall21.equals (neighborCall25)) && !(neighborCall24.equals (neighborCall25)) ) ;
                                                                                              
                                                                                             // check object generalization27 is really bound
                                                                                             JavaSDM.ensure ( generalization27 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(generalization23.equals (generalization27)) ) ;
                                                                                              
                                                                                             // check object normalMediator is really bound
                                                                                             JavaSDM.ensure ( normalMediator != null ) ;
                                                                                              
                                                                                             // create link
                                                                                             normalMediator.addToAntecedentAnnos (neighborCall21);
                                                                                              
                                                                                             // create link
                                                                                             normalMediator.addToAntecedentAnnos (generalization23);
                                                                                              
                                                                                             // create link
                                                                                             normalMediator.addToAntecedentAnnos (neighborCall24);
                                                                                              
                                                                                             // create link
                                                                                             normalMediator.addToAntecedentAnnos (neighborCall25);
                                                                                              
                                                                                             // create link
                                                                                             normalMediator.addToAntecedentAnnos (generalization27);
                                                                                              
                                                                                             fujaba__Success = true ;
                                                                                          }
                                                                                          catch ( JavaSDMException fujaba__InternalException )
                                                                                          {
                                                                                             fujaba__Success = false ;
                                                                                          }
                                                                                           
                                                                                          return (normalMediator) ;
                                                                                       }
                                                                                    } //  end for each flow
                                                                                 }
                                                                                 catch ( JavaSDMException fujaba__InternalException )
                                                                                 {
                                                                                 }
                                                                              }
                                                                           }
                                                                           catch ( JavaSDMException fujaba__InternalException )
                                                                           {
                                                                           }
                                                                        }
                                                                     }
                                                                     catch ( JavaSDMException fujaba__InternalException )
                                                                     {
                                                                     }
                                                                  }
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object normalMediator is really bound
            JavaSDM.ensure ( normalMediator != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (normalMediator) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("mediator", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("colleague", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof NeighborCallAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof GeneralizationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof NeighborCallAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof NeighborCallAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof GeneralizationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterColleagueAnnotationsGeneralization31 = null ;
      Iterator fujaba__IterColleagueAnnotationsGeneralization37 = null ;
      Iterator fujaba__IterColleagueAnnotationsGeneralization48 = null ;
      Iterator fujaba__IterColleagueAnnotationsGeneralization54 = null ;
      Iterator fujaba__IterColleagueMethodsUMLMethod33 = null ;
      Iterator fujaba__IterColleagueMethodsUMLMethod44 = null ;
      Iterator fujaba__IterColleagueMethodsUMLMethod50 = null ;
      Iterator fujaba__IterConcreteColleague1MethodsUMLMethod32 = null ;
      Iterator fujaba__IterConcreteColleague1MethodsUMLMethod38 = null ;
      Iterator fujaba__IterConcreteColleague1MethodsUMLMethod55 = null ;
      Iterator fujaba__IterConcreteColleague2MethodsUMLMethod49 = null ;
      Iterator fujaba__IterGeneralization31ElementsConcreteColleague1 = null ;
      Iterator fujaba__IterGeneralization37ElementsConcreteColleague1 = null ;
      Iterator fujaba__IterGeneralization48ElementsConcreteColleague2 = null ;
      Iterator fujaba__IterGeneralization54ElementsConcreteColleague1 = null ;
      Iterator fujaba__IterMediatorMethodsM1 = null ;
      Iterator fujaba__IterMediatorMethodsM2 = null ;
      Iterator fujaba__IterMediatorMethodsUMLMethod28 = null ;
      Iterator fujaba__IterMediatorMethodsUMLMethod39 = null ;
      Iterator fujaba__IterMediatorMethodsUMLMethod43 = null ;
      Iterator fujaba__IterMediatorMethodsUMLMethod45 = null ;
      Iterator fujaba__IterMediatorMethodsUMLMethod57 = null ;
      Iterator fujaba__IterNeighborCall29ElementsUMLMethod30 = null ;
      Iterator fujaba__IterNeighborCall34ElementsUMLMethod35 = null ;
      Iterator fujaba__IterNeighborCall34ElementsUMLMethod36 = null ;
      Iterator fujaba__IterNeighborCall40ElementsUMLMethod41 = null ;
      Iterator fujaba__IterNeighborCall40ElementsUMLMethod42 = null ;
      Iterator fujaba__IterNeighborCall46ElementsUMLMethod47 = null ;
      Iterator fujaba__IterNeighborCall51ElementsUMLMethod52 = null ;
      Iterator fujaba__IterNeighborCall51ElementsUMLMethod53 = null ;
      Iterator fujaba__IterNeighborCall56ElementsM1 = null ;
      Iterator fujaba__IterNeighborCall58ElementsUMLMethod59 = null ;
      Iterator fujaba__IterNeighborCall58ElementsUMLMethod60 = null ;
      Iterator fujaba__IterUMLMethod28AnnotationsNeighborCall29 = null ;
      Iterator fujaba__IterUMLMethod33AnnotationsNeighborCall34 = null ;
      Iterator fujaba__IterUMLMethod39AnnotationsNeighborCall40 = null ;
      Iterator fujaba__IterUMLMethod45AnnotationsNeighborCall46 = null ;
      Iterator fujaba__IterUMLMethod50AnnotationsNeighborCall51 = null ;
      Iterator fujaba__IterUMLMethod55AnnotationsNeighborCall56 = null ;
      Iterator fujaba__IterUMLMethod57AnnotationsNeighborCall58 = null ;
      GeneralizationAnnotation generalization31 = null ;
      GeneralizationAnnotation generalization37 = null ;
      GeneralizationAnnotation generalization48 = null ;
      GeneralizationAnnotation generalization54 = null ;
      NeighborCallAnnotation neighborCall29 = null ;
      NeighborCallAnnotation neighborCall34 = null ;
      NeighborCallAnnotation neighborCall40 = null ;
      NeighborCallAnnotation neighborCall46 = null ;
      NeighborCallAnnotation neighborCall51 = null ;
      NeighborCallAnnotation neighborCall56 = null ;
      NeighborCallAnnotation neighborCall58 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLClass colleague = null ;
      de.uni_paderborn.fujaba.uml.UMLClass concreteColleague1 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass concreteColleague2 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass mediator = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod m1 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod m2 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod28 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod30 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod32 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod33 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod35 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod36 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod38 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod39 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod41 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod42 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod43 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod44 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod45 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod47 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod49 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod50 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod52 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod53 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod55 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod57 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod59 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod60 = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("NeighborCall") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            mediator = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod28: UMLMethod
            fujaba__IterMediatorMethodsUMLMethod28 = mediator.iteratorOfMethods () ;
            while ( fujaba__IterMediatorMethodsUMLMethod28.hasNext () )
            {
               try
               {
                  uMLMethod28 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterMediatorMethodsUMLMethod28.next () ;
                   
                  // bind neighborCall29: NeighborCallAnnotation
                  fujaba__IterUMLMethod28AnnotationsNeighborCall29 = uMLMethod28.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLMethod28AnnotationsNeighborCall29.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLMethod28AnnotationsNeighborCall29.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                        neighborCall29 = (NeighborCallAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between neighborCall29 and uMLMethod28
                        JavaSDM.ensure ( neighborCall29.hasInElements ("callee", uMLMethod28) ) ;
                         
                        // bind uMLMethod30: UMLMethod
                        fujaba__IterNeighborCall29ElementsUMLMethod30 = neighborCall29.iteratorOfElements ("caller") ;
                        while ( fujaba__IterNeighborCall29ElementsUMLMethod30.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterNeighborCall29ElementsUMLMethod30.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              uMLMethod30 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLMethod28.equals (uMLMethod30)) ) ;
                               
                              // bind colleague: UMLClass
                              colleague = uMLMethod30.getParent () ;
                              JavaSDM.ensure ( colleague != null ) ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                               
                              // bind generalization31: GeneralizationAnnotation
                              fujaba__IterColleagueAnnotationsGeneralization31 = colleague.iteratorOfAnnotations () ;
                              while ( fujaba__IterColleagueAnnotationsGeneralization31.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterColleagueAnnotationsGeneralization31.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                    generalization31 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between generalization31 and colleague
                                    JavaSDM.ensure ( generalization31.hasInElements ("superClass", colleague) ) ;
                                     
                                    // bind concreteColleague1: UMLClass
                                    fujaba__IterGeneralization31ElementsConcreteColleague1 = generalization31.iteratorOfElements ("subClass") ;
                                    while ( fujaba__IterGeneralization31ElementsConcreteColleague1.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterGeneralization31ElementsConcreteColleague1.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                          concreteColleague1 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(mediator.equals (concreteColleague1)) && !(colleague.equals (concreteColleague1)) ) ;
                                           
                                          // bind uMLMethod32: UMLMethod
                                          fujaba__IterConcreteColleague1MethodsUMLMethod32 = concreteColleague1.iteratorOfMethods () ;
                                          while ( fujaba__IterConcreteColleague1MethodsUMLMethod32.hasNext () )
                                          {
                                             try
                                             {
                                                uMLMethod32 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterConcreteColleague1MethodsUMLMethod32.next () ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(uMLMethod28.equals (uMLMethod32)) && !(uMLMethod30.equals (uMLMethod32)) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   set.add (uMLMethod32);
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            colleague = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod33: UMLMethod
            fujaba__IterColleagueMethodsUMLMethod33 = colleague.iteratorOfMethods () ;
            while ( fujaba__IterColleagueMethodsUMLMethod33.hasNext () )
            {
               try
               {
                  uMLMethod33 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterColleagueMethodsUMLMethod33.next () ;
                   
                  // bind neighborCall34: NeighborCallAnnotation
                  fujaba__IterUMLMethod33AnnotationsNeighborCall34 = uMLMethod33.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLMethod33AnnotationsNeighborCall34.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLMethod33AnnotationsNeighborCall34.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                        neighborCall34 = (NeighborCallAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between neighborCall34 and uMLMethod33
                        JavaSDM.ensure ( neighborCall34.hasInElements ("caller", uMLMethod33) ) ;
                         
                        // bind uMLMethod35: UMLMethod
                        fujaba__IterNeighborCall34ElementsUMLMethod35 = neighborCall34.iteratorOfElements ("callee") ;
                        while ( fujaba__IterNeighborCall34ElementsUMLMethod35.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterNeighborCall34ElementsUMLMethod35.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              uMLMethod35 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLMethod33.equals (uMLMethod35)) ) ;
                               
                              // bind mediator: UMLClass
                              mediator = uMLMethod35.getParent () ;
                              JavaSDM.ensure ( mediator != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(colleague.equals (mediator)) ) ;
                               
                              // bind m1: UMLMethod
                              fujaba__IterMediatorMethodsM1 = mediator.iteratorOfMethods () ;
                              while ( fujaba__IterMediatorMethodsM1.hasNext () )
                              {
                                 try
                                 {
                                    m1 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterMediatorMethodsM1.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLMethod33.equals (m1)) && !(uMLMethod35.equals (m1)) ) ;
                                     
                                    {
                                       //  for each flow
                                       set.add (m1);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall34 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod36: UMLMethod
            fujaba__IterNeighborCall34ElementsUMLMethod36 = neighborCall34.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall34ElementsUMLMethod36.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall34ElementsUMLMethod36.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod36 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind colleague: UMLClass
                  colleague = uMLMethod36.getParent () ;
                  JavaSDM.ensure ( colleague != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                   
                  // bind generalization37: GeneralizationAnnotation
                  fujaba__IterColleagueAnnotationsGeneralization37 = colleague.iteratorOfAnnotations () ;
                  while ( fujaba__IterColleagueAnnotationsGeneralization37.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterColleagueAnnotationsGeneralization37.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization37 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization37 and colleague
                        JavaSDM.ensure ( generalization37.hasInElements ("superClass", colleague) ) ;
                         
                        // bind concreteColleague1: UMLClass
                        fujaba__IterGeneralization37ElementsConcreteColleague1 = generalization37.iteratorOfElements ("subClass") ;
                        while ( fujaba__IterGeneralization37ElementsConcreteColleague1.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterGeneralization37ElementsConcreteColleague1.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              concreteColleague1 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(colleague.equals (concreteColleague1)) ) ;
                               
                              // bind uMLMethod38: UMLMethod
                              fujaba__IterConcreteColleague1MethodsUMLMethod38 = concreteColleague1.iteratorOfMethods () ;
                              while ( fujaba__IterConcreteColleague1MethodsUMLMethod38.hasNext () )
                              {
                                 try
                                 {
                                    uMLMethod38 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterConcreteColleague1MethodsUMLMethod38.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLMethod36.equals (uMLMethod38)) ) ;
                                     
                                    {
                                       //  for each flow
                                       set.add (uMLMethod38);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("Generalization") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            mediator = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod39: UMLMethod
            fujaba__IterMediatorMethodsUMLMethod39 = mediator.iteratorOfMethods () ;
            while ( fujaba__IterMediatorMethodsUMLMethod39.hasNext () )
            {
               try
               {
                  uMLMethod39 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterMediatorMethodsUMLMethod39.next () ;
                   
                  // bind neighborCall40: NeighborCallAnnotation
                  fujaba__IterUMLMethod39AnnotationsNeighborCall40 = uMLMethod39.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLMethod39AnnotationsNeighborCall40.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLMethod39AnnotationsNeighborCall40.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                        neighborCall40 = (NeighborCallAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between neighborCall40 and uMLMethod39
                        JavaSDM.ensure ( neighborCall40.hasInElements ("callee", uMLMethod39) ) ;
                         
                        // bind uMLMethod41: UMLMethod
                        fujaba__IterNeighborCall40ElementsUMLMethod41 = neighborCall40.iteratorOfElements ("caller") ;
                        while ( fujaba__IterNeighborCall40ElementsUMLMethod41.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterNeighborCall40ElementsUMLMethod41.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              uMLMethod41 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLMethod39.equals (uMLMethod41)) ) ;
                               
                              // bind colleague: UMLClass
                              colleague = uMLMethod41.getParent () ;
                              JavaSDM.ensure ( colleague != null ) ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (colleague);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            colleague = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (colleague);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall40 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod42: UMLMethod
            fujaba__IterNeighborCall40ElementsUMLMethod42 = neighborCall40.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall40ElementsUMLMethod42.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall40ElementsUMLMethod42.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod42 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind colleague: UMLClass
                  colleague = uMLMethod42.getParent () ;
                  JavaSDM.ensure ( colleague != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (colleague);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("NeighborCall") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            mediator = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod43: UMLMethod
            fujaba__IterMediatorMethodsUMLMethod43 = mediator.iteratorOfMethods () ;
            while ( fujaba__IterMediatorMethodsUMLMethod43.hasNext () )
            {
               try
               {
                  uMLMethod43 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterMediatorMethodsUMLMethod43.next () ;
                   
                  {
                     //  for each flow
                     set.add (uMLMethod43);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            colleague = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod44: UMLMethod
            fujaba__IterColleagueMethodsUMLMethod44 = colleague.iteratorOfMethods () ;
            while ( fujaba__IterColleagueMethodsUMLMethod44.hasNext () )
            {
               try
               {
                  uMLMethod44 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterColleagueMethodsUMLMethod44.next () ;
                   
                  {
                     //  for each flow
                     set.add (uMLMethod44);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("NeighborCall") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            mediator = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod45: UMLMethod
            fujaba__IterMediatorMethodsUMLMethod45 = mediator.iteratorOfMethods () ;
            while ( fujaba__IterMediatorMethodsUMLMethod45.hasNext () )
            {
               try
               {
                  uMLMethod45 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterMediatorMethodsUMLMethod45.next () ;
                   
                  // bind neighborCall46: NeighborCallAnnotation
                  fujaba__IterUMLMethod45AnnotationsNeighborCall46 = uMLMethod45.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLMethod45AnnotationsNeighborCall46.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLMethod45AnnotationsNeighborCall46.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                        neighborCall46 = (NeighborCallAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between neighborCall46 and uMLMethod45
                        JavaSDM.ensure ( neighborCall46.hasInElements ("callee", uMLMethod45) ) ;
                         
                        // bind uMLMethod47: UMLMethod
                        fujaba__IterNeighborCall46ElementsUMLMethod47 = neighborCall46.iteratorOfElements ("caller") ;
                        while ( fujaba__IterNeighborCall46ElementsUMLMethod47.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterNeighborCall46ElementsUMLMethod47.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              uMLMethod47 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLMethod45.equals (uMLMethod47)) ) ;
                               
                              // bind colleague: UMLClass
                              colleague = uMLMethod47.getParent () ;
                              JavaSDM.ensure ( colleague != null ) ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                               
                              // bind generalization48: GeneralizationAnnotation
                              fujaba__IterColleagueAnnotationsGeneralization48 = colleague.iteratorOfAnnotations () ;
                              while ( fujaba__IterColleagueAnnotationsGeneralization48.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterColleagueAnnotationsGeneralization48.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                    generalization48 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between generalization48 and colleague
                                    JavaSDM.ensure ( generalization48.hasInElements ("superClass", colleague) ) ;
                                     
                                    // bind concreteColleague2: UMLClass
                                    fujaba__IterGeneralization48ElementsConcreteColleague2 = generalization48.iteratorOfElements ("subClass") ;
                                    while ( fujaba__IterGeneralization48ElementsConcreteColleague2.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterGeneralization48ElementsConcreteColleague2.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                          concreteColleague2 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(mediator.equals (concreteColleague2)) && !(colleague.equals (concreteColleague2)) ) ;
                                           
                                          // bind uMLMethod49: UMLMethod
                                          fujaba__IterConcreteColleague2MethodsUMLMethod49 = concreteColleague2.iteratorOfMethods () ;
                                          while ( fujaba__IterConcreteColleague2MethodsUMLMethod49.hasNext () )
                                          {
                                             try
                                             {
                                                uMLMethod49 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterConcreteColleague2MethodsUMLMethod49.next () ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(uMLMethod45.equals (uMLMethod49)) && !(uMLMethod47.equals (uMLMethod49)) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   set.add (uMLMethod49);
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            colleague = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod50: UMLMethod
            fujaba__IterColleagueMethodsUMLMethod50 = colleague.iteratorOfMethods () ;
            while ( fujaba__IterColleagueMethodsUMLMethod50.hasNext () )
            {
               try
               {
                  uMLMethod50 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterColleagueMethodsUMLMethod50.next () ;
                   
                  // bind neighborCall51: NeighborCallAnnotation
                  fujaba__IterUMLMethod50AnnotationsNeighborCall51 = uMLMethod50.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLMethod50AnnotationsNeighborCall51.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLMethod50AnnotationsNeighborCall51.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                        neighborCall51 = (NeighborCallAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between neighborCall51 and uMLMethod50
                        JavaSDM.ensure ( neighborCall51.hasInElements ("caller", uMLMethod50) ) ;
                         
                        // bind uMLMethod52: UMLMethod
                        fujaba__IterNeighborCall51ElementsUMLMethod52 = neighborCall51.iteratorOfElements ("callee") ;
                        while ( fujaba__IterNeighborCall51ElementsUMLMethod52.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterNeighborCall51ElementsUMLMethod52.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              uMLMethod52 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLMethod50.equals (uMLMethod52)) ) ;
                               
                              // bind mediator: UMLClass
                              mediator = uMLMethod52.getParent () ;
                              JavaSDM.ensure ( mediator != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(colleague.equals (mediator)) ) ;
                               
                              // bind m2: UMLMethod
                              fujaba__IterMediatorMethodsM2 = mediator.iteratorOfMethods () ;
                              while ( fujaba__IterMediatorMethodsM2.hasNext () )
                              {
                                 try
                                 {
                                    m2 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterMediatorMethodsM2.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLMethod50.equals (m2)) && !(uMLMethod52.equals (m2)) ) ;
                                     
                                    {
                                       //  for each flow
                                       set.add (m2);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall51 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod53: UMLMethod
            fujaba__IterNeighborCall51ElementsUMLMethod53 = neighborCall51.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall51ElementsUMLMethod53.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall51ElementsUMLMethod53.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod53 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind colleague: UMLClass
                  colleague = uMLMethod53.getParent () ;
                  JavaSDM.ensure ( colleague != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                   
                  // bind generalization54: GeneralizationAnnotation
                  fujaba__IterColleagueAnnotationsGeneralization54 = colleague.iteratorOfAnnotations () ;
                  while ( fujaba__IterColleagueAnnotationsGeneralization54.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterColleagueAnnotationsGeneralization54.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization54 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization54 and colleague
                        JavaSDM.ensure ( generalization54.hasInElements ("superClass", colleague) ) ;
                         
                        // bind concreteColleague1: UMLClass
                        fujaba__IterGeneralization54ElementsConcreteColleague1 = generalization54.iteratorOfElements ("subClass") ;
                        while ( fujaba__IterGeneralization54ElementsConcreteColleague1.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterGeneralization54ElementsConcreteColleague1.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              concreteColleague1 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(colleague.equals (concreteColleague1)) ) ;
                               
                              // bind uMLMethod55: UMLMethod
                              fujaba__IterConcreteColleague1MethodsUMLMethod55 = concreteColleague1.iteratorOfMethods () ;
                              while ( fujaba__IterConcreteColleague1MethodsUMLMethod55.hasNext () )
                              {
                                 try
                                 {
                                    uMLMethod55 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterConcreteColleague1MethodsUMLMethod55.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLMethod53.equals (uMLMethod55)) ) ;
                                     
                                    // bind neighborCall56: NeighborCallAnnotation
                                    fujaba__IterUMLMethod55AnnotationsNeighborCall56 = uMLMethod55.iteratorOfAnnotations () ;
                                    while ( fujaba__IterUMLMethod55AnnotationsNeighborCall56.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterUMLMethod55AnnotationsNeighborCall56.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                          neighborCall56 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between neighborCall56 and uMLMethod55
                                          JavaSDM.ensure ( neighborCall56.hasInElements ("callee", uMLMethod55) ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(neighborCall51.equals (neighborCall56)) ) ;
                                           
                                          // bind m1: UMLMethod
                                          fujaba__IterNeighborCall56ElementsM1 = neighborCall56.iteratorOfElements ("caller") ;
                                          while ( fujaba__IterNeighborCall56ElementsM1.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterNeighborCall56ElementsM1.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                m1 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(uMLMethod53.equals (m1)) && !(uMLMethod55.equals (m1)) ) ;
                                                 
                                                // bind mediator: UMLClass
                                                mediator = m1.getParent () ;
                                                JavaSDM.ensure ( mediator != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(colleague.equals (mediator)) && !(concreteColleague1.equals (mediator)) ) ;
                                                 
                                                // bind m2: UMLMethod
                                                fujaba__IterMediatorMethodsM2 = mediator.iteratorOfMethods () ;
                                                while ( fujaba__IterMediatorMethodsM2.hasNext () )
                                                {
                                                   try
                                                   {
                                                      m2 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterMediatorMethodsM2.next () ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(uMLMethod53.equals (m2)) && !(uMLMethod55.equals (m2)) && !(m1.equals (m2)) ) ;
                                                       
                                                      {
                                                         //  for each flow
                                                         set.add (m2);
                                                      } //  end for each flow
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("Generalization") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            mediator = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod57: UMLMethod
            fujaba__IterMediatorMethodsUMLMethod57 = mediator.iteratorOfMethods () ;
            while ( fujaba__IterMediatorMethodsUMLMethod57.hasNext () )
            {
               try
               {
                  uMLMethod57 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterMediatorMethodsUMLMethod57.next () ;
                   
                  // bind neighborCall58: NeighborCallAnnotation
                  fujaba__IterUMLMethod57AnnotationsNeighborCall58 = uMLMethod57.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLMethod57AnnotationsNeighborCall58.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLMethod57AnnotationsNeighborCall58.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                        neighborCall58 = (NeighborCallAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between neighborCall58 and uMLMethod57
                        JavaSDM.ensure ( neighborCall58.hasInElements ("callee", uMLMethod57) ) ;
                         
                        // bind uMLMethod59: UMLMethod
                        fujaba__IterNeighborCall58ElementsUMLMethod59 = neighborCall58.iteratorOfElements ("caller") ;
                        while ( fujaba__IterNeighborCall58ElementsUMLMethod59.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterNeighborCall58ElementsUMLMethod59.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              uMLMethod59 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLMethod57.equals (uMLMethod59)) ) ;
                               
                              // bind colleague: UMLClass
                              colleague = uMLMethod59.getParent () ;
                              JavaSDM.ensure ( colleague != null ) ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(mediator.equals (colleague)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (colleague);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            colleague = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (colleague);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall58 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod60: UMLMethod
            fujaba__IterNeighborCall58ElementsUMLMethod60 = neighborCall58.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall58ElementsUMLMethod60.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall58ElementsUMLMethod60.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  uMLMethod60 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind colleague: UMLClass
                  colleague = uMLMethod60.getParent () ;
                  JavaSDM.ensure ( colleague != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (colleague.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (colleague);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
